#! /usr/local/bin/apl --script
⍝ ********************************************************************
⍝ diff.apl Workspace to compare two directories of code
⍝ Copyright (C) 2021 Bill Daly

⍝ This program is free software: you can redistribute it and/or modify
⍝ it under the terms of the GNU General Public License as published by
⍝ the Free Software Foundation, either version 3 of the License, or
⍝ (at your option) any later version.

⍝ This program is distributed in the hope that it will be useful,
⍝ but WITHOUT ANY WARRANTY; without even the implied warranty of
⍝ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
⍝ GNU General Public License for more details.

⍝ You should have received a copy of the GNU General Public License
⍝ along with this program.  If not, see <http://www.gnu.org/licenses/>.

⍝ ********************************************************************

)copy_once 5 FILE_IO
)copy_once 1 utl

∇tst←diff∆isDir fstat                                                 
⍝ Function examines the vector returned by FIO∆fstat to determine if
⍝ it is a directory file                                            
tst←∧/0 4=((8⍴8)⊤fstat[3])[3 4]                                     
∇

∇tst←diff∆isRegular fstat;ftype                                       
⍝ Function examines the vector returned by FIO∆fstat to determine if
⍝ it is a regular file                                              
tst←∧/1 0=((8⍴8)⊤fstat[3])[3 4]                                     
∇

∇s←diff∆fsize fstat                                                   
⍝ Function extracts the size of a file from the results of FIO∆fstat
s←fstat[8]                                                          
∇

∇rs←dira diff∆compare dirb;files;i;fh;skip;cmd;sink
  ⍝ Function compares two directories and returns all the items in
  ⍝ dira that should be copied to dirb.
  files←FIO∆files_in_directory dira
  lb←((count←⍴files)⍴start),end
  fstat←count⍴⍬
  i←⎕io
  rs←''
start:
  fh ← 'r' FIO∆fopen dira,'/',i⊃files
  skip←diff∆isDir FIO∆fstat fh
  sink←FIO∆fclose fh
  →skip/disp
  rs←rs,⎕tc[3] cmd←'FIO∆pipefrom ''diff ',dira,'/',(i⊃files),' ',dirb,'/',(i⊃files),''''
  rs←rs,⎕tc[3],⍎cmd
disp:
  →lb[i←i+1]
end:
∇


